# -*- coding: utf-8 -*-

import time

from ..internal.Account import Account
"""SYNO"""
from ..internal.misc import json
"""SYNO END"""


class DepositfilesCom(Account):
    __name__ = "DepositfilesCom"
    __type__ = "account"
    """SYNO"""
    __version__ = "0.40"
    """SYNO END"""
    __status__ = "testing"

    __description__ = """Depositfiles.com account plugin"""
    __license__ = "GPLv3"
    """SYNO"""
    __authors__ = [("mkaay", "mkaay@mkaay.de"),
                   ("stickell", "l.stickell@yahoo.it"),
                   ("Walter Purcaro", "vuolter@gmail.com"),
                   ("Synology PAT", "pat@synology.com")]
    """SYNO END"""

    """SYNO"""
    LOGIN_URL = "https://depositfiles.com/api/user/login"
    """SYNO END"""

    def grab_info(self, user, password, data):
        """SYNO"""
        is_premium = True if 'gold' == data['account_mode'] else False

        gold_expired = data['gold_expired']
        validuntil = None if gold_expired is None else \
            time.mktime(time.strptime(gold_expired, "%Y-%m-%d %H:%M:%S"))

        return {'validuntil': validuntil, 'trafficleft': -1, 'premium': is_premium}
        """SYNO END"""

    def signin(self, user, password, data):
        """SYNO"""
        html = self.load(self.LOGIN_URL,
                         post={'login': user,
                               'password': password})
        json_data = json.loads(html)

        if (json_data is None) or (json_data['status_code'] == 0):
            if json_data['error_code'] == 104:  # error: CaptchaRequired
                # FIXME: Handle in different way
                self.fail_login()
            else:
                self.fail_login()

        if json_data['data'] is not None:
            data['gold_expired'] = json_data['data']['gold_expired']
            data['account_mode'] = json_data['data']['mode']
        """SYNO END"""
