# -*- coding: utf-8 -*-

import re
import time

from ..internal.Account import Account


class FilefactoryCom(Account):
    __name__ = "FilefactoryCom"
    __type__ = "account"
    """SYNO"""
    __version__ = "0.24"
    """SYNO END"""
    __status__ = "testing"

    __description__ = """Filefactory.com account plugin"""
    __license__ = "GPLv3"
    """SYNO"""
    __authors__ = [("zoidberg", "zoidberg@mujmail.cz"),
                   ("stickell", "l.stickell@yahoo.it"),
                   ("GammaC0de", "nitzo2001[AT]yahoo[DOT]com"),
                   ("Synology PAT", "pat@synology.com")]
    """SYNO END"""

    """SYNO"""
    PREMIUM_PATTERN = r'id="trafficshare_usage"'
    """SYNO END"""
    VALID_UNTIL_PATTERN = r'Premium valid until: <strong>(?P<D>\d{1,2})\w{1,2} (?P<M>\w{3}), (?P<Y>\d{4})</strong>'

    def grab_info(self, user, password, data):
        html = self.load("http://www.filefactory.com/account/")

        """SYNO"""
        if not re.search(self.PREMIUM_PATTERN, html):
            return {'premium': False}
        """SYNO END"""

        m = re.search(self.VALID_UNTIL_PATTERN, html)
        if m is not None:
            validuntil = re.sub(
                self.VALID_UNTIL_PATTERN,
                '\g<D> \g<M> \g<Y>',
                m.group(0))
            validuntil = time.mktime(time.strptime(validuntil, "%d %b %Y"))

        else:
            """SYNO"""
            # Lifetime account
            """SYNO END"""
            validuntil = -1

        """SYNO"""
        return {'premium': True, 'trafficleft': -
                1, 'validuntil': validuntil}
        """SYNO END"""

    def signin(self, user, password, data):
        html = self.load("https://www.filefactory.com/member/signin.php")
        if "/member/signout.php" in html:
            self.skip_login()

        html = self.load("https://www.filefactory.com/member/signin.php",
                         post={'loginEmail': user,
                               'loginPassword': password,
                               'Submit': "Sign In"})

        if "/member/signout.php" not in html:
            self.fail_login()
