# -*- coding: utf-8 -*-

from ..internal.Account import Account
from ..internal.misc import set_cookie


class FourSharedCom(Account):
    __name__ = "FourSharedCom"
    __type__ = "account"
    """SYNO"""
    __version__ = "0.14"
    """SYNO END"""
    __status__ = "testing"

    __description__ = """FourShared.com account plugin"""
    __license__ = "GPLv3"
    """SYNO"""
    __authors__ = [("zoidberg", "zoidberg@mujmail.cz"),
                   ("stickell", "l.stickell@yahoo.it"),
                   ("Synology PAT", "pat@synology.com")]
    """SYNO END"""

    def grab_info(self, user, password, data):
        """SYNO"""
        html = self.load("https://www.4shared.com/web/account/settings/overview")
        isPremium = False
        if '<div class="trafficDigits floatRight alignRight bold">Premium</div>' in html:
            isPremium = True

        return {'premium': isPremium}
        """SYNO END"""

    def signin(self, user, password, data):
        set_cookie(self.req.cj, "4shared.com", "4langcookie", "en")

        res = self.load("https://www.4shared.com/web/login",
                        post={'login': user,
                              'password': password,
                              'remember': "on",
                              '_remember': "on",
                              'returnTo': "http://www.4shared.com/account/home.jsp"})

        if 'Please log in to access your 4shared account' in res:
            self.fail_login()
