# -*- coding: utf-8 -*-

import pycurl
from module.common.json_layer import json_loads
from ..internal.Account import Account
from ..internal.misc import set_cookie


class GigasizeCom(Account):
    __name__    = "GigasizeCom"
    __type__    = "account"
    __version__ = "0.21"
    __status__  = "testing"

    __description__ = """Gigasize account plugin"""
    __authors__     = [("Synology PAT", "pat@synology.com")]


    def grab_info(self, user, password, data):
        return { 'premium': data.get('premium', False) }


    def signin(self, user, password, data):
        token = self.load("http://www.gigasize.com/formtoken")

        self.req.http.c.setopt(pycurl.HTTPHEADER, ["X-Requested-With: XMLHttpRequest"])
        response = self.load("http://www.gigasize.com/signin",
            post = {
                "token": token,
                "email": user,
                "password": password,
                "func": '',
                "signRem": 1
            }
        )
        self.req.http.c.setopt(pycurl.HTTPHEADER, ["X-Requested-With:"])

        json = json_loads(response)
        data['premium'] = bool(json.get('premium', False))
        if json.get('status', 0) != 1:
            self.fail_login()
