# -*- coding: utf-8 -*-
import os
import time

from module.plugins.internal.Addon import Addon
from module.plugins.internal.misc import threaded
from module.Api import Api

class SYNOAutoShutDown(Addon):
    __name__ = "SYNOAutoShutDown"
    __type__ = "hook"
    __version__ = "0.01"

    __config__ = [("activated", "bool", "Activated", True)]

    __description__ = """Synology auto shut down hook plugin"""
    __license__ = ""
    __authors__ = [("Synology PAT", "pat@synology.com")]

    def coreReady(self):
        self.log_info(_("in coreReady"));
        self.monitor();

    @threaded
    def monitor(self):
        """don't check tasks queue in first 30 seconds"""
        time.sleep(30)
        while 1:
            """get all packages in download queue"""
            queueData = self.pyload.files.getCompleteData(1)
            deleteList = []
            for pid in queueData.keys():
                record = queueData[pid]
                links = record['links']
                link = links.itervalues().next()
                status = link['status']
                """remove finished, offline, failed and aborted tasks, status map is in pyFile.py"""
                if status in (0, 1, 4, 8, 9):
                    deleteList.append(pid)
            """shut down if there is no tasks in queue"""
            self.removeTask(deleteList)
            if 0 == len(queueData.keys()):
                self.pyload.do_kill = True

            time.sleep(10)

    def removeTask(self, pidList):
        if 0 == len(pidList):
            return
        getattr(Api, 'deletePackages')(self.pyload.api, pidList)


