# -*- coding: utf-8 -*-
import socket
import os
import struct
import json

from module.plugins.internal.Addon import Addon
from module.plugins.internal.misc import threaded
from module.Api import Api
from subprocess import call

class SYNODeleteTask(Addon):
    __name__ = "SYNODeleteTask"
    __type__ = "hook"
    __version__ = "0.01"

    __config__ = [("activated", "bool", "Activated", True)]

    __description__ = """Synology delete task hook plugin"""
    __license__ = ""
    __authors__ = [("Synology PAT", "pat@synology.com")]

    def coreReady(self):
        self.log_info(_("in coreReady"));
        self.server();

    @threaded
    def server(self):
        socketname = self.pyload.synoDeleteTaskDomainsocketPath
        try:
            os.unlink(socketname)
        except OSError:
            pass
        sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
        os.umask(0117)
        sock.bind(socketname);
        os.umask(0077)
        try:
            syno_credentials_tool_path = os.path.join(self.pyload.syno_package_path, "target", "bin", "synodlcredentialstool")
            call([syno_credentials_tool_path, "--set-pyload"])
        except subprocess.CalledProcessError, e:
            self.log_info(str(e))
        sock.listen(5);

        while True:
            connection, client_address = sock.accept()
            try:
                #read header
                data = connection.recv(4);
                if len(data) != 4:
                    raise Exception("Wrong data size");
                taskId = struct.unpack('I', data)[0]
                #call responding api
                self.callApi(taskId)
                raw = struct.pack('I', True)
                connection.sendall(raw)
            except Exception as err:
                self.log_info(str(err))
            finally:
                connection.close()

    def callApi(self, taskId):
        taskList = []
        taskList.append(taskId)
        argsArray = []
        argsArray.append(taskList)
        ret = getattr(Api, "deletePackagesSYNO")(self.pyload.api, *argsArray)
        return ret
