# -*- coding: utf-8 -*-

import re

from module.common.json_layer import json_loads
from module.plugins.internal.SimpleHoster import SimpleHoster


class GigasizeCom(SimpleHoster):
    __name__    = "GigasizeCom"
    __type__    = "hoster"
    __version__ = "0.21"
    __status__  = "testing"

    __pattern__ = r'https?://(?:www\.)?(gigasize\.com)/get/(?P<ID>[a-z0-9]+)'
    __config__  = [("activated"  , "bool", "Activated"                       , True),
                   ("use_premium", "bool", "Use premium account if available", True)]

    __description__ = """Gigasize hoster plugin"""
    __authors__     = [("Synology PAT", "pat@synology.com")]

    LOGIN_PREMIUM = True


    def handle_premium(self, pyfile):
        token = self.load("http://www.gigasize.com/formtoken")
        response = self.load("http://www.gigasize.com/getoken",
            post = {
                "fileId": self.info['pattern']['ID'],
                "token": token
            }
        )

        json = json_loads(response)
        self.link = json['redirect']

        title = re.search(r'<strong (?:.*?)title="(.*?)">', self.data)
        pyfile.name = title.group(1)
