#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import getopt
from os import chdir
from os.path import join
import json
import __builtin__
__builtin__.pypath = "/var/packages/DownloadStation/target/pyload/"
__builtin__.pyconfdir = "/var/services/download/pyload/"

def list_account():
    import module.plugins.SynoPluginManager
    p = module.plugins.SynoPluginManager.PluginManager('listAccountPlugin')
    accountPlugins = p.listAccountPlugin()
    print json.dumps(accountPlugins)

def verify_account(host, user, password):
    import module.plugins.SynoPluginManager
    p = module.plugins.SynoPluginManager.PluginManager('verifyAccount')
    bl_valid, bl_premium = p.verifyAccount(host, user, password)
    print json.dumps({'valid': bl_valid, 'premium': bl_premium})

def set_account(host, user, password):
    import module.plugins.SynoPluginManager
    p = module.plugins.SynoPluginManager.PluginManager('setAccount')
    p.setAccount(host, user, password)

def set_enabled(host, enabled):
    import module.plugins.SynoPluginManager
    module.plugins.SynoPluginManager.PluginManager.setEnabled(host, enabled)

def check_url(url):
    import module.plugins.SynoPluginManager
    p = module.plugins.SynoPluginManager.PluginManager('checkURL')
    if p.checkURL(url):
        blFound = True
    else:
        blFound = False
    print json.dumps({'result': blFound})

def main():
    try:
        opt, args = getopt.getopt(sys.argv[1:], "lvscedf:n:p:u:", ["list", "verify", "set", "check", "enable", "disable", "host=", "user=", "password=", "url="])
    except getopt.GetoptError:
        sys.exit(1)

    _list_account = False
    _verify_account = False
    _set_account = False
    _check_url = False
    _enable = False
    _disable = False

    for o, a in opt:
        if o in ('-l', '--list'):
            _list_account = True
        if o in ('-v', '--verify'):
            _verify_account = True
        if o in ('-s', '--set-account'):
            _set_account = True
        if o in ('-c', '--check'):
            _check_url = True
        if o in ('-e', '--enable'):
            _enable = True
        if o in ('-d', '--disable'):
            _disable = True
        if o in ('-f', '--host'):
            _host = a
        if o in ('-n', '--user'):
            _user = a
        if o in ('-p', '--password'):
            _password = a
        if o in ('-u', '--url'):
            _url = a

    try:
        chdir(pyconfdir)
        if _list_account:
            list_account()
        elif _verify_account and '_host' in locals() and '_user' in locals():
            verify_account(_host, _user, _password if '_password' in locals() else None)
        elif _set_account:
            set_account(_host, _user, _password)
        elif _check_url:
            check_url(_url)
        elif _enable:
            set_enabled(_host, True)
        elif _disable:
            set_enabled(_host, False)
        else:
            sys.exit(1)
    except ValueError as err:
        print str(err)
        sys.exit(1)
    except Exception as e:
        sys.exit(1)
    sys.exit(0)


if __name__ == "__main__":
    main()
