#!/bin/sh
# Copyright (c) 2017-2017 Synology Inc. All rights reserved.

SOURCE_ETC_DIR="/usr/syno/etc/packages/DownloadStation"
DESTINATION_BASE_DIR=$1
DESTINATION_ETC_DIR="${DESTINATION_BASE_DIR}/usr/syno/etc/packages/DownloadStation"

copy_and_filter_out() { # <filter pattern> <source file> <destination file>
	local pattern=$1 src_file=$2 dest_file=$3
	[ -r "$src_file" ] || return 1
	/bin/grep -v "$pattern" "$src_file" > "$dest_file"
}


create_etc_directories() {
	local dest_dir="${DESTINATION_ETC_DIR}/download"
	[ -w "$dest_dir" ] || /bin/mkdir -p "$dest_dir"
}

collect_etc_settings_conf() {
	local filter="\(download_[a-z]*_\(user\|password_en\)\)="
	local src_file="${SOURCE_ETC_DIR}/settings.conf"
	local dest_file="${DESTINATION_ETC_DIR}/settings.conf"
	copy_and_filter_out "$filter" "$src_file" "$dest_file"
}

collect_etc_download_settings_json() {
	local filter="\"rpc-password\""
	local src_file="${SOURCE_ETC_DIR}/download/settings.json"
	local dest_file="${DESTINATION_ETC_DIR}/download/settings.json"
	copy_and_filter_out "$filter" "$src_file" "$dest_file"
}

create_etc_directories
collect_etc_settings_conf
collect_etc_download_settings_json

exit 0
