-- vim:ft=sql

BEGIN;

CREATE TABLE notification (
	id SERIAL,
	task_id int4 NOT NULL,
	type text NOT NULL,
	create_time bigint,
	CONSTRAINT notification_id_pkey PRIMARY KEY (id),
	CONSTRAINT notification_task_id_fkey FOREIGN KEY(task_id) REFERENCES download_queue(task_id) ON DELETE CASCADE ON UPDATE CASCADE
);

CREATE OR REPLACE FUNCTION notify_fail() RETURNS TRIGGER AS
$BODY$
BEGIN
    PERFORM insert_notification(new.task_id, 'failed', cast(extract(epoch from now()) as integer));
    RETURN new;
END;
$BODY$
language plpgsql;

CREATE OR REPLACE FUNCTION notify_captcha() RETURNS TRIGGER AS
$BODY$
BEGIN
    PERFORM insert_notification(new.task_id, 'captcha', cast(extract(epoch from now()) as integer));
    RETURN new;
END;
$BODY$
language plpgsql;

CREATE OR REPLACE FUNCTION insert_notification(INT, TEXT, INT) RETURNS VOID AS
$BODY$
BEGIN
    INSERT INTO
        notification(task_id, type, create_time)
        VALUES($1, $2, $3);
END;
$BODY$
language plpgsql;


CREATE TRIGGER "onTaskFailed"
AFTER UPDATE OF status ON download_queue
FOR EACH ROW
	WHEN (NEW.status>100)
		EXECUTE PROCEDURE notify_fail();
CREATE TRIGGER "onTaskCAPTCHA"
AFTER UPDATE OF status ON download_queue
FOR EACH ROW
	WHEN (NEW.status=15)
		EXECUTE PROCEDURE notify_captcha();

COMMIT;

