BEGIN;

CREATE OR REPLACE FUNCTION lo_unlink_non_raise(oid OID) RETURNS VOID AS
$$
BEGIN
    PERFORM lo_unlink(oid) WHERE oid != 0;
EXCEPTION
    WHEN others THEN
        -- Do nothing
END;
$$
LANGUAGE plpgsql;

CREATE OR REPLACE RULE propagate_deletes_to_lob as
    ON DELETE TO download_queue
    DO ALSO (SELECT lo_unlink_non_raise(OLD.file_oid));

COMMIT;

